﻿using System;

using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;

namespace BackgroundTest {
    public partial class MainForm : Form {
        public MainForm() {
            InitializeComponent();
        }


        private void menuWork_Click(object sender, EventArgs e) {
            menuWork.Enabled = false;
            backgroundWorker.RunWorkerAsync(0);
        }

        private void menuExit_Click(object sender, EventArgs e) {
            backgroundWorker.CancelAsync();
            this.Close();
        }


        private void backgroundWorker_DoWork(object sender, Medo.ComponentModel.DoWorkEventArgs e) {
            int startAt = (int)e.Argument;

            for (int i = 0; i < 100; ++i) {
                Thread.Sleep(25);
                if (backgroundWorker.CancellationPending) {
                    e.Cancel = true;
                    return;
                }
                backgroundWorker.ReportProgress(i, DateTime.Now);
            }
        }

        private void backgroundWorker_ProgressChanged(object sender, Medo.ComponentModel.ProgressChangedEventArgs e) {
            labelStatus.Text = e.ProgressPercentage.ToString() + "%\n\n" + e.UserState.ToString();
        }

        private void backgroundWorker_RunWorkerCompleted(object sender, Medo.ComponentModel.RunWorkerCompletedEventArgs e) {
            menuWork.Enabled = true;
            labelStatus.Text = "-";
        }

    }
}